=== modified file 'bzrlib/plugins/weave_fmt/workingtree.py'
--- bzrlib/plugins/weave_fmt/workingtree.py	2011-04-09 22:12:01 +0000
+++ bzrlib/plugins/weave_fmt/workingtree.py	2011-04-09 22:51:57 +0000
@@ -30,8 +30,8 @@
 from bzrlib.decorators import needs_read_lock
 from bzrlib.transport.local import LocalTransport
 from bzrlib.workingtree import (
+    InventoryWorkingTree,
     WorkingTreeFormat,
-    WorkingTree,
     )
 
 
@@ -133,7 +133,7 @@
         return wt
 
 
-class WorkingTree2(WorkingTree):
+class WorkingTree2(InventoryWorkingTree):
     """This is the Format 2 working tree.
 
     This was the first weave based working tree.

=== modified file 'bzrlib/workingtree.py'
--- bzrlib/workingtree.py	2011-04-11 20:01:54 +0000
+++ bzrlib/workingtree.py	2011-04-15 10:31:18 +0000
@@ -166,16 +166,10 @@
         return ''
 
 
-class WorkingTree(bzrlib.mutabletree.MutableInventoryTree,
+class WorkingTree(bzrlib.mutabletree.MutableTree,
     controldir.ControlComponent):
     """Working copy tree.
 
-    The inventory is held in the `Branch` working-inventory, and the
-    files are in a directory on disk.
-
-    It is possible for a `WorkingTree` to have a filename which is
-    not listed in the Inventory and vice versa.
-
     :ivar basedir: The root of the tree on disk. This is a unicode path object
         (as opposed to a URL).
     """
@@ -186,7 +180,6 @@
 
     def __init__(self, basedir='.',
                  branch=DEPRECATED_PARAMETER,
-                 _inventory=None,
                  _control_files=None,
                  _internal=False,
                  _format=None,
@@ -229,16 +222,6 @@
             mutter("write hc")
             hc.write()
 
-        if _inventory is None:
-            # This will be acquired on lock_read() or lock_write()
-            self._inventory_is_modified = False
-            self._inventory = None
-        else:
-            # the caller of __init__ has provided an inventory,
-            # we assume they know what they are doing - as its only
-            # the Format factory and creation methods that are
-            # permitted to do this.
-            self._set_inventory(_inventory, dirty=False)
         self._detect_case_handling()
         self._rules_searcher = None
         self.views = self._make_views()
@@ -315,19 +298,6 @@
     def supports_views(self):
         return self.views.supports_views()
 
-    def _set_inventory(self, inv, dirty):
-        """Set the internal cached inventory.
-
-        :param inv: The inventory to set.
-        :param dirty: A boolean indicating whether the inventory is the same
-            logical inventory as whats on disk. If True the inventory is not
-            the same and should be written to disk or data will be lost, if
-            False then the inventory is the same as that on disk and any
-            serialisation would be unneeded overhead.
-        """
-        self._inventory = inv
-        self._inventory_is_modified = dirty
-
     @staticmethod
     def open(path=None, _unsupported=False):
         """Open an existing working tree at path.
@@ -446,23 +416,9 @@
                                               list_current=list_current)
         return [tr for tr in iterator if tr is not None]
 
-    # should be deprecated - this is slow and in any case treating them as a
-    # container is (we now know) bad style -- mbp 20070302
-    ## @deprecated_method(zero_fifteen)
-    def __iter__(self):
-        """Iterate through file_ids for this tree.
-
-        file_ids are in a WorkingTree if they are in the working inventory
-        and the working file exists.
-        """
-        inv = self._inventory
-        for path, ie in inv.iter_entries():
-            if osutils.lexists(self.abspath(path)):
-                yield ie.file_id
-
     def all_file_ids(self):
         """See Tree.iter_all_file_ids"""
-        return set(self.inventory)
+        raise NotImplementedError(self.all_file_ids)
 
     def __repr__(self):
         return "<%s of %s>" % (self.__class__.__name__,
@@ -558,54 +514,6 @@
         finally:
             file.close()
 
-    @needs_read_lock
-    def annotate_iter(self, file_id, default_revision=CURRENT_REVISION):
-        """See Tree.annotate_iter
-
-        This implementation will use the basis tree implementation if possible.
-        Lines not in the basis are attributed to CURRENT_REVISION
-
-        If there are pending merges, lines added by those merges will be
-        incorrectly attributed to CURRENT_REVISION (but after committing, the
-        attribution will be correct).
-        """
-        maybe_file_parent_keys = []
-        for parent_id in self.get_parent_ids():
-            try:
-                parent_tree = self.revision_tree(parent_id)
-            except errors.NoSuchRevisionInTree:
-                parent_tree = self.branch.repository.revision_tree(parent_id)
-            parent_tree.lock_read()
-            try:
-                if file_id not in parent_tree:
-                    continue
-                ie = parent_tree.inventory[file_id]
-                if ie.kind != 'file':
-                    # Note: this is slightly unnecessary, because symlinks and
-                    # directories have a "text" which is the empty text, and we
-                    # know that won't mess up annotations. But it seems cleaner
-                    continue
-                parent_text_key = (file_id, ie.revision)
-                if parent_text_key not in maybe_file_parent_keys:
-                    maybe_file_parent_keys.append(parent_text_key)
-            finally:
-                parent_tree.unlock()
-        graph = _mod_graph.Graph(self.branch.repository.texts)
-        heads = graph.heads(maybe_file_parent_keys)
-        file_parent_keys = []
-        for key in maybe_file_parent_keys:
-            if key in heads:
-                file_parent_keys.append(key)
-
-        # Now we have the parents of this content
-        annotator = self.branch.repository.texts.get_annotator()
-        text = self.get_file_text(file_id)
-        this_key =(file_id, default_revision)
-        annotator.add_special_text(this_key, file_parent_keys, text)
-        annotations = [(key[-1], line)
-                       for key, line in annotator.annotate_flat(this_key)]
-        return annotations
-
     def _get_ancestors(self, default_revision):
         ancestors = set([default_revision])
         for parent_id in self.get_parent_ids():
@@ -634,10 +542,9 @@
                 parents.append(revision_id)
         return parents
 
-    @needs_read_lock
     def get_root_id(self):
         """Return the id of this trees root"""
-        return self._inventory.root.file_id
+        raise NotImplementedError(self.get_root_id)
 
     @needs_read_lock
     def clone(self, to_bzrdir, revision_id=None):
@@ -673,21 +580,6 @@
     def id2abspath(self, file_id):
         return self.abspath(self.id2path(file_id))
 
-    def has_id(self, file_id):
-        # files that have been deleted are excluded
-        inv = self.inventory
-        if not inv.has_id(file_id):
-            return False
-        path = inv.id2path(file_id)
-        return osutils.lexists(self.abspath(path))
-
-    def has_or_had_id(self, file_id):
-        if file_id == self.inventory.root.file_id:
-            return True
-        return self.inventory.has_id(file_id)
-
-    __contains__ = has_id
-
     def get_file_size(self, file_id):
         """See Tree.get_file_size"""
         # XXX: this returns the on-disk size; it should probably return the
@@ -700,59 +592,9 @@
             else:
                 return None
 
-    @needs_read_lock
     def get_file_sha1(self, file_id, path=None, stat_value=None):
-        if not path:
-            path = self._inventory.id2path(file_id)
-        return self._hashcache.get_sha1(path, stat_value)
-
-    def get_file_mtime(self, file_id, path=None):
-        if not path:
-            path = self.inventory.id2path(file_id)
-        return os.lstat(self.abspath(path)).st_mtime
-
-    def _is_executable_from_path_and_stat_from_basis(self, path, stat_result):
-        file_id = self.path2id(path)
-        if file_id is None:
-            # For unversioned files on win32, we just assume they are not
-            # executable
-            return False
-        return self._inventory[file_id].executable
-
-    def _is_executable_from_path_and_stat_from_stat(self, path, stat_result):
-        mode = stat_result.st_mode
-        return bool(stat.S_ISREG(mode) and stat.S_IEXEC & mode)
-
-    if not supports_executable():
-        def is_executable(self, file_id, path=None):
-            return self._inventory[file_id].executable
-
-        _is_executable_from_path_and_stat = \
-            _is_executable_from_path_and_stat_from_basis
-    else:
-        def is_executable(self, file_id, path=None):
-            if not path:
-                path = self.id2path(file_id)
-            mode = os.lstat(self.abspath(path)).st_mode
-            return bool(stat.S_ISREG(mode) and stat.S_IEXEC & mode)
-
-        _is_executable_from_path_and_stat = \
-            _is_executable_from_path_and_stat_from_stat
-
-    @needs_tree_write_lock
-    def _add(self, files, ids, kinds):
-        """See MutableTree._add."""
-        # TODO: Re-adding a file that is removed in the working copy
-        # should probably put it back with the previous ID.
-        # the read and write working inventory should not occur in this
-        # function - they should be part of lock_write and unlock.
-        inv = self.inventory
-        for f, file_id, kind in zip(files, ids, kinds):
-            if file_id is None:
-                inv.add_path(f, kind=kind)
-            else:
-                inv.add_path(f, kind=kind, file_id=file_id)
-            self._inventory_is_modified = True
+        # FIXME: Shouldn't this be in Tree?
+        raise NotImplementedError(self.get_file_sha1)
 
     @needs_tree_write_lock
     def _gather_kinds(self, files, kinds):
@@ -1020,7 +862,6 @@
         merger.set_pending()
         return conflicts
 
-    @needs_read_lock
     def merge_modified(self):
         """Return a dictionary of files modified by a merge.
 
@@ -1031,28 +872,7 @@
         This returns a map of file_id->sha1, containing only files which are
         still in the working inventory and have that text hash.
         """
-        try:
-            hashfile = self._transport.get('merge-hashes')
-        except errors.NoSuchFile:
-            return {}
-        try:
-            merge_hashes = {}
-            try:
-                if hashfile.next() != MERGE_MODIFIED_HEADER_1 + '\n':
-                    raise errors.MergeModifiedFormatError()
-            except StopIteration:
-                raise errors.MergeModifiedFormatError()
-            for s in _mod_rio.RioReader(hashfile):
-                # RioReader reads in Unicode, so convert file_ids back to utf8
-                file_id = osutils.safe_file_id(s.get("file_id"), warn=False)
-                if file_id not in self.inventory:
-                    continue
-                text_hash = s.get("hash")
-                if text_hash == self.get_file_sha1(file_id):
-                    merge_hashes[file_id] = text_hash
-            return merge_hashes
-        finally:
-            hashfile.close()
+        raise NotImplementedError(self.merge_modified)
 
     @needs_write_lock
     def mkdir(self, path, file_id=None):
@@ -1068,47 +888,8 @@
         target = osutils.readlink(abspath)
         return target
 
-    @needs_write_lock
     def subsume(self, other_tree):
-        def add_children(inventory, entry):
-            for child_entry in entry.children.values():
-                inventory._byid[child_entry.file_id] = child_entry
-                if child_entry.kind == 'directory':
-                    add_children(inventory, child_entry)
-        if other_tree.get_root_id() == self.get_root_id():
-            raise errors.BadSubsumeSource(self, other_tree,
-                                          'Trees have the same root')
-        try:
-            other_tree_path = self.relpath(other_tree.basedir)
-        except errors.PathNotChild:
-            raise errors.BadSubsumeSource(self, other_tree,
-                'Tree is not contained by the other')
-        new_root_parent = self.path2id(osutils.dirname(other_tree_path))
-        if new_root_parent is None:
-            raise errors.BadSubsumeSource(self, other_tree,
-                'Parent directory is not versioned.')
-        # We need to ensure that the result of a fetch will have a
-        # versionedfile for the other_tree root, and only fetching into
-        # RepositoryKnit2 guarantees that.
-        if not self.branch.repository.supports_rich_root():
-            raise errors.SubsumeTargetNeedsUpgrade(other_tree)
-        other_tree.lock_tree_write()
-        try:
-            new_parents = other_tree.get_parent_ids()
-            other_root = other_tree.inventory.root
-            other_root.parent_id = new_root_parent
-            other_root.name = osutils.basename(other_tree_path)
-            self.inventory.add(other_root)
-            add_children(self.inventory, other_root)
-            self._write_inventory(self.inventory)
-            # normally we don't want to fetch whole repositories, but i think
-            # here we really do want to consolidate the whole thing.
-            for parent_id in other_tree.get_parent_ids():
-                self.branch.fetch(other_tree.branch, parent_id)
-                self.add_parent_tree_id(parent_id)
-        finally:
-            other_tree.unlock()
-        other_tree.bzrdir.retire_bzrdir()
+        raise NotImplementedError(self.subsume)
 
     def _setup_directory_is_tree_reference(self):
         if self._branch.repository._format.supports_tree_reference:
@@ -1136,74 +917,16 @@
         # checkout in a subdirectory.  This can be avoided by not adding
         # it.  mbp 20070306
 
-    @needs_tree_write_lock
     def extract(self, file_id, format=None):
         """Extract a subtree from this tree.
 
         A new branch will be created, relative to the path for this tree.
         """
-        self.flush()
-        def mkdirs(path):
-            segments = osutils.splitpath(path)
-            transport = self.branch.bzrdir.root_transport
-            for name in segments:
-                transport = transport.clone(name)
-                transport.ensure_base()
-            return transport
-
-        sub_path = self.id2path(file_id)
-        branch_transport = mkdirs(sub_path)
-        if format is None:
-            format = self.bzrdir.cloning_metadir()
-        branch_transport.ensure_base()
-        branch_bzrdir = format.initialize_on_transport(branch_transport)
-        try:
-            repo = branch_bzrdir.find_repository()
-        except errors.NoRepositoryPresent:
-            repo = branch_bzrdir.create_repository()
-        if not repo.supports_rich_root():
-            raise errors.RootNotRich()
-        new_branch = branch_bzrdir.create_branch()
-        new_branch.pull(self.branch)
-        for parent_id in self.get_parent_ids():
-            new_branch.fetch(self.branch, parent_id)
-        tree_transport = self.bzrdir.root_transport.clone(sub_path)
-        if tree_transport.base != branch_transport.base:
-            tree_bzrdir = format.initialize_on_transport(tree_transport)
-            branch.BranchReferenceFormat().initialize(tree_bzrdir,
-                target_branch=new_branch)
-        else:
-            tree_bzrdir = branch_bzrdir
-        wt = tree_bzrdir.create_workingtree(_mod_revision.NULL_REVISION)
-        wt.set_parent_ids(self.get_parent_ids())
-        my_inv = self.inventory
-        child_inv = inventory.Inventory(root_id=None)
-        new_root = my_inv[file_id]
-        my_inv.remove_recursive_id(file_id)
-        new_root.parent_id = None
-        child_inv.add(new_root)
-        self._write_inventory(my_inv)
-        wt._write_inventory(child_inv)
-        return wt
-
-    def _serialize(self, inventory, out_file):
-        xml5.serializer_v5.write_inventory(self._inventory, out_file,
-            working=True)
-
-    def _deserialize(selt, in_file):
-        return xml5.serializer_v5.read_inventory(in_file)
+        raise NotImplementedError(self.extract)
 
     def flush(self):
-        """Write the in memory inventory to disk."""
-        # TODO: Maybe this should only write on dirty ?
-        if self._control_files._lock_mode != 'w':
-            raise errors.NotWriteLocked(self)
-        sio = StringIO()
-        self._serialize(self._inventory, sio)
-        sio.seek(0)
-        self._transport.put_file('inventory', sio,
-            mode=self.bzrdir._get_file_mode())
-        self._inventory_is_modified = False
+        """Write the in memory meta data to disk."""
+        raise NotImplementedError(self.flush)
 
     def _kind(self, relpath):
         return osutils.file_kind(self.abspath(relpath))
@@ -1219,127 +942,12 @@
         :param from_dir: start from this directory or None for the root
         :param recursive: whether to recurse into subdirectories or not
         """
-        # list_files is an iterator, so @needs_read_lock doesn't work properly
-        # with it. So callers should be careful to always read_lock the tree.
-        if not self.is_locked():
-            raise errors.ObjectNotLocked(self)
-
-        inv = self.inventory
-        if from_dir is None and include_root is True:
-            yield ('', 'V', 'directory', inv.root.file_id, inv.root)
-        # Convert these into local objects to save lookup times
-        pathjoin = osutils.pathjoin
-        file_kind = self._kind
-
-        # transport.base ends in a slash, we want the piece
-        # between the last two slashes
-        transport_base_dir = self.bzrdir.transport.base.rsplit('/', 2)[1]
-
-        fk_entries = {'directory':TreeDirectory, 'file':TreeFile, 'symlink':TreeLink}
-
-        # directory file_id, relative path, absolute path, reverse sorted children
-        if from_dir is not None:
-            from_dir_id = inv.path2id(from_dir)
-            if from_dir_id is None:
-                # Directory not versioned
-                return
-            from_dir_abspath = pathjoin(self.basedir, from_dir)
-        else:
-            from_dir_id = inv.root.file_id
-            from_dir_abspath = self.basedir
-        children = os.listdir(from_dir_abspath)
-        children.sort()
-        # jam 20060527 The kernel sized tree seems equivalent whether we
-        # use a deque and popleft to keep them sorted, or if we use a plain
-        # list and just reverse() them.
-        children = collections.deque(children)
-        stack = [(from_dir_id, u'', from_dir_abspath, children)]
-        while stack:
-            from_dir_id, from_dir_relpath, from_dir_abspath, children = stack[-1]
-
-            while children:
-                f = children.popleft()
-                ## TODO: If we find a subdirectory with its own .bzr
-                ## directory, then that is a separate tree and we
-                ## should exclude it.
-
-                # the bzrdir for this tree
-                if transport_base_dir == f:
-                    continue
-
-                # we know that from_dir_relpath and from_dir_abspath never end in a slash
-                # and 'f' doesn't begin with one, we can do a string op, rather
-                # than the checks of pathjoin(), all relative paths will have an extra slash
-                # at the beginning
-                fp = from_dir_relpath + '/' + f
-
-                # absolute path
-                fap = from_dir_abspath + '/' + f
-
-                dir_ie = inv[from_dir_id]
-                if dir_ie.kind == 'directory':
-                    f_ie = dir_ie.children.get(f)
-                else:
-                    f_ie = None
-                if f_ie:
-                    c = 'V'
-                elif self.is_ignored(fp[1:]):
-                    c = 'I'
-                else:
-                    # we may not have found this file, because of a unicode
-                    # issue, or because the directory was actually a symlink.
-                    f_norm, can_access = osutils.normalized_filename(f)
-                    if f == f_norm or not can_access:
-                        # No change, so treat this file normally
-                        c = '?'
-                    else:
-                        # this file can be accessed by a normalized path
-                        # check again if it is versioned
-                        # these lines are repeated here for performance
-                        f = f_norm
-                        fp = from_dir_relpath + '/' + f
-                        fap = from_dir_abspath + '/' + f
-                        f_ie = inv.get_child(from_dir_id, f)
-                        if f_ie:
-                            c = 'V'
-                        elif self.is_ignored(fp[1:]):
-                            c = 'I'
-                        else:
-                            c = '?'
-
-                fk = file_kind(fap)
-
-                # make a last minute entry
-                if f_ie:
-                    yield fp[1:], c, fk, f_ie.file_id, f_ie
-                else:
-                    try:
-                        yield fp[1:], c, fk, None, fk_entries[fk]()
-                    except KeyError:
-                        yield fp[1:], c, fk, None, TreeEntry()
-                    continue
-
-                if fk != 'directory':
-                    continue
-
-                # But do this child first if recursing down
-                if recursive:
-                    new_children = os.listdir(fap)
-                    new_children.sort()
-                    new_children = collections.deque(new_children)
-                    stack.append((f_ie.file_id, fp, fap, new_children))
-                    # Break out of inner loop,
-                    # so that we start outer loop with child
-                    break
-            else:
-                # if we finished all children, pop it off the stack
-                stack.pop()
-
-    @needs_tree_write_lock
+        raise NotImplementedError(self.list_files)
+
     def move(self, from_paths, to_dir=None, after=False):
         """Rename files.
 
-        to_dir must exist in the inventory.
+        to_dir must be known to the working tree.
 
         If to_dir exists and is a directory, the files are moved into
         it, keeping their old names.
@@ -1351,9 +959,8 @@
         independently.
 
         The first mode moves the file in the filesystem and updates the
-        inventory. The second mode only updates the inventory without
-        touching the file on the filesystem. This is the new mode introduced
-        in version 0.15.
+        working tree metadata. The second mode only updates the working tree
+        metadata without touching the file on the filesystem.
 
         move uses the second mode if 'after == True' and the target is not
         versioned but present in the working tree.
@@ -1371,168 +978,7 @@
         This returns a list of (from_path, to_path) pairs for each
         entry that is moved.
         """
-        rename_entries = []
-        rename_tuples = []
-
-        # check for deprecated use of signature
-        if to_dir is None:
-            raise TypeError('You must supply a target directory')
-        # check destination directory
-        if isinstance(from_paths, basestring):
-            raise ValueError()
-        inv = self.inventory
-        to_abs = self.abspath(to_dir)
-        if not isdir(to_abs):
-            raise errors.BzrMoveFailedError('',to_dir,
-                errors.NotADirectory(to_abs))
-        if not self.has_filename(to_dir):
-            raise errors.BzrMoveFailedError('',to_dir,
-                errors.NotInWorkingDirectory(to_dir))
-        to_dir_id = inv.path2id(to_dir)
-        if to_dir_id is None:
-            raise errors.BzrMoveFailedError('',to_dir,
-                errors.NotVersionedError(path=to_dir))
-
-        to_dir_ie = inv[to_dir_id]
-        if to_dir_ie.kind != 'directory':
-            raise errors.BzrMoveFailedError('',to_dir,
-                errors.NotADirectory(to_abs))
-
-        # create rename entries and tuples
-        for from_rel in from_paths:
-            from_tail = splitpath(from_rel)[-1]
-            from_id = inv.path2id(from_rel)
-            if from_id is None:
-                raise errors.BzrMoveFailedError(from_rel,to_dir,
-                    errors.NotVersionedError(path=from_rel))
-
-            from_entry = inv[from_id]
-            from_parent_id = from_entry.parent_id
-            to_rel = pathjoin(to_dir, from_tail)
-            rename_entry = WorkingTree._RenameEntry(from_rel=from_rel,
-                                         from_id=from_id,
-                                         from_tail=from_tail,
-                                         from_parent_id=from_parent_id,
-                                         to_rel=to_rel, to_tail=from_tail,
-                                         to_parent_id=to_dir_id)
-            rename_entries.append(rename_entry)
-            rename_tuples.append((from_rel, to_rel))
-
-        # determine which move mode to use. checks also for movability
-        rename_entries = self._determine_mv_mode(rename_entries, after)
-
-        original_modified = self._inventory_is_modified
-        try:
-            if len(from_paths):
-                self._inventory_is_modified = True
-            self._move(rename_entries)
-        except:
-            # restore the inventory on error
-            self._inventory_is_modified = original_modified
-            raise
-        self._write_inventory(inv)
-        return rename_tuples
-
-    def _determine_mv_mode(self, rename_entries, after=False):
-        """Determines for each from-to pair if both inventory and working tree
-        or only the inventory has to be changed.
-
-        Also does basic plausability tests.
-        """
-        inv = self.inventory
-
-        for rename_entry in rename_entries:
-            # store to local variables for easier reference
-            from_rel = rename_entry.from_rel
-            from_id = rename_entry.from_id
-            to_rel = rename_entry.to_rel
-            to_id = inv.path2id(to_rel)
-            only_change_inv = False
-
-            # check the inventory for source and destination
-            if from_id is None:
-                raise errors.BzrMoveFailedError(from_rel,to_rel,
-                    errors.NotVersionedError(path=from_rel))
-            if to_id is not None:
-                raise errors.BzrMoveFailedError(from_rel,to_rel,
-                    errors.AlreadyVersionedError(path=to_rel))
-
-            # try to determine the mode for rename (only change inv or change
-            # inv and file system)
-            if after:
-                if not self.has_filename(to_rel):
-                    raise errors.BzrMoveFailedError(from_id,to_rel,
-                        errors.NoSuchFile(path=to_rel,
-                        extra="New file has not been created yet"))
-                only_change_inv = True
-            elif not self.has_filename(from_rel) and self.has_filename(to_rel):
-                only_change_inv = True
-            elif self.has_filename(from_rel) and not self.has_filename(to_rel):
-                only_change_inv = False
-            elif (not self.case_sensitive
-                  and from_rel.lower() == to_rel.lower()
-                  and self.has_filename(from_rel)):
-                only_change_inv = False
-            else:
-                # something is wrong, so lets determine what exactly
-                if not self.has_filename(from_rel) and \
-                   not self.has_filename(to_rel):
-                    raise errors.BzrRenameFailedError(from_rel,to_rel,
-                        errors.PathsDoNotExist(paths=(str(from_rel),
-                        str(to_rel))))
-                else:
-                    raise errors.RenameFailedFilesExist(from_rel, to_rel)
-            rename_entry.only_change_inv = only_change_inv
-        return rename_entries
-
-    def _move(self, rename_entries):
-        """Moves a list of files.
-
-        Depending on the value of the flag 'only_change_inv', the
-        file will be moved on the file system or not.
-        """
-        inv = self.inventory
-        moved = []
-
-        for entry in rename_entries:
-            try:
-                self._move_entry(entry)
-            except:
-                self._rollback_move(moved)
-                raise
-            moved.append(entry)
-
-    def _rollback_move(self, moved):
-        """Try to rollback a previous move in case of an filesystem error."""
-        inv = self.inventory
-        for entry in moved:
-            try:
-                self._move_entry(WorkingTree._RenameEntry(
-                    entry.to_rel, entry.from_id,
-                    entry.to_tail, entry.to_parent_id, entry.from_rel,
-                    entry.from_tail, entry.from_parent_id,
-                    entry.only_change_inv))
-            except errors.BzrMoveFailedError, e:
-                raise errors.BzrMoveFailedError( '', '', "Rollback failed."
-                        " The working tree is in an inconsistent state."
-                        " Please consider doing a 'bzr revert'."
-                        " Error message is: %s" % e)
-
-    def _move_entry(self, entry):
-        inv = self.inventory
-        from_rel_abs = self.abspath(entry.from_rel)
-        to_rel_abs = self.abspath(entry.to_rel)
-        if from_rel_abs == to_rel_abs:
-            raise errors.BzrMoveFailedError(entry.from_rel, entry.to_rel,
-                "Source and target are identical.")
-
-        if not entry.only_change_inv:
-            try:
-                osutils.rename(from_rel_abs, to_rel_abs)
-            except OSError, e:
-                raise errors.BzrMoveFailedError(entry.from_rel,
-                    entry.to_rel, e[1])
-        inv.rename(entry.from_id, entry.to_parent_id, entry.to_tail)
+        raise NotImplementedError(self.move)
 
     @needs_tree_write_lock
     def rename_one(self, from_rel, to_rel, after=False):
@@ -1542,8 +988,7 @@
 
         rename_one has several 'modes' to work. First, it can rename a physical
         file and change the file_id. That is the normal mode. Second, it can
-        only change the file_id without touching any physical file. This is
-        the new mode introduced in version 0.15.
+        only change the file_id without touching any physical file.
 
         rename_one uses the second mode if 'after == True' and 'to_rel' is not
         versioned but present in the working tree.
@@ -1558,67 +1003,7 @@
 
         Everything else results in an error.
         """
-        inv = self.inventory
-        rename_entries = []
-
-        # create rename entries and tuples
-        from_tail = splitpath(from_rel)[-1]
-        from_id = inv.path2id(from_rel)
-        if from_id is None:
-            # if file is missing in the inventory maybe it's in the basis_tree
-            basis_tree = self.branch.basis_tree()
-            from_id = basis_tree.path2id(from_rel)
-            if from_id is None:
-                raise errors.BzrRenameFailedError(from_rel,to_rel,
-                    errors.NotVersionedError(path=from_rel))
-            # put entry back in the inventory so we can rename it
-            from_entry = basis_tree.inventory[from_id].copy()
-            inv.add(from_entry)
-        else:
-            from_entry = inv[from_id]
-        from_parent_id = from_entry.parent_id
-        to_dir, to_tail = os.path.split(to_rel)
-        to_dir_id = inv.path2id(to_dir)
-        rename_entry = WorkingTree._RenameEntry(from_rel=from_rel,
-                                     from_id=from_id,
-                                     from_tail=from_tail,
-                                     from_parent_id=from_parent_id,
-                                     to_rel=to_rel, to_tail=to_tail,
-                                     to_parent_id=to_dir_id)
-        rename_entries.append(rename_entry)
-
-        # determine which move mode to use. checks also for movability
-        rename_entries = self._determine_mv_mode(rename_entries, after)
-
-        # check if the target changed directory and if the target directory is
-        # versioned
-        if to_dir_id is None:
-            raise errors.BzrMoveFailedError(from_rel,to_rel,
-                errors.NotVersionedError(path=to_dir))
-
-        # all checks done. now we can continue with our actual work
-        mutter('rename_one:\n'
-               '  from_id   {%s}\n'
-               '  from_rel: %r\n'
-               '  to_rel:   %r\n'
-               '  to_dir    %r\n'
-               '  to_dir_id {%s}\n',
-               from_id, from_rel, to_rel, to_dir, to_dir_id)
-
-        self._move(rename_entries)
-        self._write_inventory(inv)
-
-    class _RenameEntry(object):
-        def __init__(self, from_rel, from_id, from_tail, from_parent_id,
-                     to_rel, to_tail, to_parent_id, only_change_inv=False):
-            self.from_rel = from_rel
-            self.from_id = from_id
-            self.from_tail = from_tail
-            self.from_parent_id = from_parent_id
-            self.to_rel = to_rel
-            self.to_tail = to_tail
-            self.to_parent_id = to_parent_id
-            self.only_change_inv = only_change_inv
+        raise NotImplementedError(self.rename_one)
 
     @needs_read_lock
     def unknowns(self):
@@ -1632,7 +1017,6 @@
         return iter(
             [subp for subp in self.extras() if not self.is_ignored(subp)])
 
-    @needs_tree_write_lock
     def unversion(self, file_ids):
         """Remove the file ids in file_ids from the current versioned set.
 
@@ -1642,22 +1026,7 @@
         :param file_ids: The file ids to stop versioning.
         :raises: NoSuchId if any fileid is not currently versioned.
         """
-        for file_id in file_ids:
-            if file_id not in self._inventory:
-                raise errors.NoSuchId(self, file_id)
-        for file_id in file_ids:
-            if self._inventory.has_id(file_id):
-                self._inventory.remove_recursive_id(file_id)
-        if len(file_ids):
-            # in the future this should just set a dirty bit to wait for the
-            # final unlock. However, until all methods of workingtree start
-            # with the current in -memory inventory rather than triggering
-            # a read, it is more complex - we need to teach read_inventory
-            # to know when to read, and when to not read first... and possibly
-            # to save first when the in memory one may be corrupted.
-            # so for now, we just only write it if it is indeed dirty.
-            # - RBC 20060907
-            self._write_inventory(self._inventory)
+        raise NotImplementedError(self.unversion)
 
     @needs_write_lock
     def pull(self, source, overwrite=False, stop_revision=None,
@@ -1728,37 +1097,7 @@
         Currently returned depth-first, sorted by name within directories.
         This is the same order used by 'osutils.walkdirs'.
         """
-        ## TODO: Work from given directory downwards
-        for path, dir_entry in self.inventory.directories():
-            # mutter("search for unknowns in %r", path)
-            dirabs = self.abspath(path)
-            if not isdir(dirabs):
-                # e.g. directory deleted
-                continue
-
-            fl = []
-            for subf in os.listdir(dirabs):
-                if self.bzrdir.is_control_filename(subf):
-                    continue
-                if subf not in dir_entry.children:
-                    try:
-                        (subf_norm,
-                         can_access) = osutils.normalized_filename(subf)
-                    except UnicodeDecodeError:
-                        path_os_enc = path.encode(osutils._fs_enc)
-                        relpath = path_os_enc + '/' + subf
-                        raise errors.BadFilenameEncoding(relpath,
-                                                         osutils._fs_enc)
-                    if subf_norm != subf and can_access:
-                        if subf_norm not in dir_entry.children:
-                            fl.append(subf_norm)
-                    else:
-                        fl.append(subf)
-
-            fl.sort()
-            for subf in fl:
-                subp = pathjoin(path, subf)
-                yield subp
+        raise NotImplementedError(self.extras)
 
     def ignored_files(self):
         """Yield list of PATH, IGNORE_PATTERN"""
@@ -1813,7 +1152,7 @@
 
     def stored_kind(self, file_id):
         """See Tree.stored_kind"""
-        return self.inventory[file_id].kind
+        raise NotImplementedError(self.stored_kind)
 
     def _comparison_data(self, entry, path):
         abspath = self.abspath(path)
@@ -1910,24 +1249,13 @@
     def get_physical_lock_status(self):
         return self._control_files.get_physical_lock_status()
 
-    def _basis_inventory_name(self):
-        return 'basis-inventory-cache'
-
     def _reset_data(self):
         """Reset transient data that cannot be revalidated."""
-        self._inventory_is_modified = False
-        f = self._transport.get('inventory')
-        try:
-            result = self._deserialize(f)
-        finally:
-            f.close()
-        self._set_inventory(result, dirty=False)
+        raise NotImplementedError(self._reset_data)
 
-    @needs_tree_write_lock
     def set_last_revision(self, new_revision):
         """Change the last revision in the working tree."""
-        if self._change_last_revision(new_revision):
-            self._cache_basis_inventory(new_revision)
+        raise NotImplementedError(self.set_last_revision)
 
     def _change_last_revision(self, new_revision):
         """Template method part of set_last_revision to perform the change.
@@ -1945,75 +1273,10 @@
             self.branch.set_revision_history([new_revision])
         return True
 
-    def _write_basis_inventory(self, xml):
-        """Write the basis inventory XML to the basis-inventory file"""
-        path = self._basis_inventory_name()
-        sio = StringIO(xml)
-        self._transport.put_file(path, sio,
-            mode=self.bzrdir._get_file_mode())
-
-    def _create_basis_xml_from_inventory(self, revision_id, inventory):
-        """Create the text that will be saved in basis-inventory"""
-        inventory.revision_id = revision_id
-        return xml7.serializer_v7.write_inventory_to_string(inventory)
-
-    def _cache_basis_inventory(self, new_revision):
-        """Cache new_revision as the basis inventory."""
-        # TODO: this should allow the ready-to-use inventory to be passed in,
-        # as commit already has that ready-to-use [while the format is the
-        # same, that is].
-        try:
-            # this double handles the inventory - unpack and repack -
-            # but is easier to understand. We can/should put a conditional
-            # in here based on whether the inventory is in the latest format
-            # - perhaps we should repack all inventories on a repository
-            # upgrade ?
-            # the fast path is to copy the raw xml from the repository. If the
-            # xml contains 'revision_id="', then we assume the right
-            # revision_id is set. We must check for this full string, because a
-            # root node id can legitimately look like 'revision_id' but cannot
-            # contain a '"'.
-            xml = self.branch.repository._get_inventory_xml(new_revision)
-            firstline = xml.split('\n', 1)[0]
-            if (not 'revision_id="' in firstline or
-                'format="7"' not in firstline):
-                inv = self.branch.repository._serializer.read_inventory_from_string(
-                    xml, new_revision)
-                xml = self._create_basis_xml_from_inventory(new_revision, inv)
-            self._write_basis_inventory(xml)
-        except (errors.NoSuchRevision, errors.RevisionNotPresent):
-            pass
-
-    def read_basis_inventory(self):
-        """Read the cached basis inventory."""
-        path = self._basis_inventory_name()
-        return self._transport.get_bytes(path)
-
-    @needs_read_lock
-    def read_working_inventory(self):
-        """Read the working inventory.
-
-        :raises errors.InventoryModified: read_working_inventory will fail
-            when the current in memory inventory has been modified.
-        """
-        # conceptually this should be an implementation detail of the tree.
-        # XXX: Deprecate this.
-        # ElementTree does its own conversion from UTF-8, so open in
-        # binary.
-        if self._inventory_is_modified:
-            raise errors.InventoryModified(self)
-        f = self._transport.get('inventory')
-        try:
-            result = self._deserialize(f)
-        finally:
-            f.close()
-        self._set_inventory(result, dirty=False)
-        return result
-
     @needs_tree_write_lock
     def remove(self, files, verbose=False, to_file=None, keep_files=True,
         force=False):
-        """Remove nominated files from the working inventory.
+        """Remove nominated files from the working tree metadata.
 
         :files: File paths relative to the basedir.
         :keep_files: If true, the files will also be kept.
@@ -2084,7 +1347,7 @@
                                                          backup_name)
 
         # Build inv_delta and delete files where applicable,
-        # do this before any modifications to inventory.
+        # do this before any modifications to meta data.
         for f in files:
             fid = self.path2id(f)
             message = None
@@ -2170,47 +1433,7 @@
         WorkingTree can supply revision_trees for the basis revision only
         because there is only one cached inventory in the bzr directory.
         """
-        if revision_id == self.last_revision():
-            try:
-                xml = self.read_basis_inventory()
-            except errors.NoSuchFile:
-                pass
-            else:
-                try:
-                    inv = xml7.serializer_v7.read_inventory_from_string(xml)
-                    # dont use the repository revision_tree api because we want
-                    # to supply the inventory.
-                    if inv.revision_id == revision_id:
-                        return revisiontree.RevisionTree(self.branch.repository,
-                            inv, revision_id)
-                except errors.BadInventoryFormat:
-                    pass
-        # raise if there was no inventory, or if we read the wrong inventory.
-        raise errors.NoSuchRevisionInTree(self, revision_id)
-
-    # XXX: This method should be deprecated in favour of taking in a proper
-    # new Inventory object.
-    @needs_tree_write_lock
-    def set_inventory(self, new_inventory_list):
-        from bzrlib.inventory import (Inventory,
-                                      InventoryDirectory,
-                                      InventoryFile,
-                                      InventoryLink)
-        inv = Inventory(self.get_root_id())
-        for path, file_id, parent, kind in new_inventory_list:
-            name = os.path.basename(path)
-            if name == "":
-                continue
-            # fixme, there should be a factory function inv,add_??
-            if kind == 'directory':
-                inv.add(InventoryDirectory(file_id, name, parent))
-            elif kind == 'file':
-                inv.add(InventoryFile(file_id, name, parent))
-            elif kind == 'symlink':
-                inv.add(InventoryLink(file_id, name, parent))
-            else:
-                raise errors.BzrError("unknown kind %r" % kind)
-        self._write_inventory(inv)
+        raise NotImplementedError(self.revision_tree)
 
     @needs_tree_write_lock
     def set_root_id(self, file_id):
@@ -2229,24 +1452,7 @@
             present in the current inventory or an error will occur. It must
             not be None, but rather a valid file id.
         """
-        inv = self._inventory
-        orig_root_id = inv.root.file_id
-        # TODO: it might be nice to exit early if there was nothing
-        # to do, saving us from trigger a sync on unlock.
-        self._inventory_is_modified = True
-        # we preserve the root inventory entry object, but
-        # unlinkit from the byid index
-        del inv._byid[inv.root.file_id]
-        inv.root.file_id = file_id
-        # and link it into the index with the new changed id.
-        inv._byid[inv.root.file_id] = inv.root
-        # and finally update all children to reference the new id.
-        # XXX: this should be safe to just look at the root.children
-        # list, not the WHOLE INVENTORY.
-        for fid in inv:
-            entry = inv[fid]
-            if entry.parent_id == orig_root_id:
-                entry.parent_id = inv.root.file_id
+        raise NotImplementedError(self._set_root_id)
 
     def unlock(self):
         """See Branch.unlock.
@@ -2360,8 +1566,7 @@
             basis = self.basis_tree()
             basis.lock_read()
             try:
-                if (basis.inventory.root is None
-                    or basis.inventory.root.file_id != to_root_id):
+                if (basis.get_root_id() is None or basis.get_root_id() != to_root_id):
                     self.set_root_id(to_root_id)
                     self.flush()
             finally:
@@ -2409,13 +1614,7 @@
                 #       warning might be sufficient to let the user know what
                 #       is going on.
                 mutter('Could not write hashcache for %s\nError: %s',
-                       self._hashcache.cache_file_name(), e)
-
-    @needs_tree_write_lock
-    def _write_inventory(self, inv):
-        """Write inventory as the current inventory."""
-        self._set_inventory(inv, dirty=True)
-        self.flush()
+                              self._hashcache.cache_file_name(), e)
 
     def set_conflicts(self, arg):
         raise errors.UnsupportedOperation(self.set_conflicts, self)
@@ -2556,35 +1755,7 @@
                  [(file1_path, file1_name, file1_kind, None, file1_id,
                    file1_kind), ... ])
         """
-        _directory = 'directory'
-        # get the root in the inventory
-        inv = self.inventory
-        top_id = inv.path2id(prefix)
-        if top_id is None:
-            pending = []
-        else:
-            pending = [(prefix, '', _directory, None, top_id, None)]
-        while pending:
-            dirblock = []
-            currentdir = pending.pop()
-            # 0 - relpath, 1- basename, 2- kind, 3- stat, 4-id, 5-kind
-            top_id = currentdir[4]
-            if currentdir[0]:
-                relroot = currentdir[0] + '/'
-            else:
-                relroot = ""
-            # FIXME: stash the node in pending
-            entry = inv[top_id]
-            if entry.kind == 'directory':
-                for name, child in entry.sorted_children():
-                    dirblock.append((relroot + name, name, child.kind, None,
-                        child.file_id, child.kind
-                        ))
-            yield (currentdir[0], entry.file_id), dirblock
-            # push the user specified dirs from dirblock
-            for dir in reversed(dirblock):
-                if dir[2] == _directory:
-                    pending.append(dir)
+        raise NotImplementedError(self._walkdirs)
 
     @needs_tree_write_lock
     def auto_resolve(self):
@@ -2659,22 +1830,13 @@
                 refs[ref] = self.branch.repository.revision_tree(value)
         self._check(refs)
 
-    @needs_tree_write_lock
     def reset_state(self, revision_ids=None):
         """Reset the state of the working tree.
 
         This does a hard-reset to a last-known-good state. This is a way to
         fix if something got corrupted (like the .bzr/checkout/dirstate file)
         """
-        if revision_ids is None:
-            revision_ids = self.get_parent_ids()
-        if not revision_ids:
-            rt = self.branch.repository.revision_tree(
-                _mod_revision.NULL_REVISION)
-        else:
-            rt = self.branch.repository.revision_tree(revision_ids[0])
-        self._write_inventory(rt.inventory)
-        self.set_parent_ids(revision_ids)
+        raise NotImplementedError(self.reset_state)
 
     def _get_rules_searcher(self, default_searcher):
         """See Tree._get_rules_searcher."""
@@ -2689,7 +1851,1044 @@
         return ShelfManager(self, self._transport)
 
 
-class WorkingTree3(WorkingTree):
+class InventoryWorkingTree(WorkingTree,
+        bzrlib.mutabletree.MutableInventoryTree):
+    """Base class for working trees that are inventory-oriented.
+
+    The inventory is held in the `Branch` working-inventory, and the
+    files are in a directory on disk.
+
+    It is possible for a `WorkingTree` to have a filename which is
+    not listed in the Inventory and vice versa.
+    """
+
+    def __init__(self, basedir='.',
+                 branch=DEPRECATED_PARAMETER,
+                 _inventory=None,
+                 _control_files=None,
+                 _internal=False,
+                 _format=None,
+                 _bzrdir=None):
+        """Construct a InventoryWorkingTree instance. This is not a public API.
+
+        :param branch: A branch to override probing for the branch.
+        """
+        super(InventoryWorkingTree, self).__init__(basedir=basedir,
+            branch=branch, _control_files=_control_files, _internal=_internal,
+            _format=_format, _bzrdir=_bzrdir)
+
+        if _inventory is None:
+            # This will be acquired on lock_read() or lock_write()
+            self._inventory_is_modified = False
+            self._inventory = None
+        else:
+            # the caller of __init__ has provided an inventory,
+            # we assume they know what they are doing - as its only
+            # the Format factory and creation methods that are
+            # permitted to do this.
+            self._set_inventory(_inventory, dirty=False)
+
+    def _set_inventory(self, inv, dirty):
+        """Set the internal cached inventory.
+
+        :param inv: The inventory to set.
+        :param dirty: A boolean indicating whether the inventory is the same
+            logical inventory as whats on disk. If True the inventory is not
+            the same and should be written to disk or data will be lost, if
+            False then the inventory is the same as that on disk and any
+            serialisation would be unneeded overhead.
+        """
+        self._inventory = inv
+        self._inventory_is_modified = dirty
+
+    def _serialize(self, inventory, out_file):
+        xml5.serializer_v5.write_inventory(self._inventory, out_file,
+            working=True)
+
+    def _deserialize(selt, in_file):
+        return xml5.serializer_v5.read_inventory(in_file)
+
+    @needs_tree_write_lock
+    def _write_inventory(self, inv):
+        """Write inventory as the current inventory."""
+        self._set_inventory(inv, dirty=True)
+        self.flush()
+
+    # XXX: This method should be deprecated in favour of taking in a proper
+    # new Inventory object.
+    @needs_tree_write_lock
+    def set_inventory(self, new_inventory_list):
+        from bzrlib.inventory import (Inventory,
+                                      InventoryDirectory,
+                                      InventoryFile,
+                                      InventoryLink)
+        inv = Inventory(self.get_root_id())
+        for path, file_id, parent, kind in new_inventory_list:
+            name = os.path.basename(path)
+            if name == "":
+                continue
+            # fixme, there should be a factory function inv,add_??
+            if kind == 'directory':
+                inv.add(InventoryDirectory(file_id, name, parent))
+            elif kind == 'file':
+                inv.add(InventoryFile(file_id, name, parent))
+            elif kind == 'symlink':
+                inv.add(InventoryLink(file_id, name, parent))
+            else:
+                raise errors.BzrError("unknown kind %r" % kind)
+        self._write_inventory(inv)
+
+    def _write_basis_inventory(self, xml):
+        """Write the basis inventory XML to the basis-inventory file"""
+        path = self._basis_inventory_name()
+        sio = StringIO(xml)
+        self._transport.put_file(path, sio,
+            mode=self.bzrdir._get_file_mode())
+
+    def _reset_data(self):
+        """Reset transient data that cannot be revalidated."""
+        self._inventory_is_modified = False
+        f = self._transport.get('inventory')
+        try:
+            result = self._deserialize(f)
+        finally:
+            f.close()
+        self._set_inventory(result, dirty=False)
+
+    def _set_root_id(self, file_id):
+        """Set the root id for this tree, in a format specific manner.
+
+        :param file_id: The file id to assign to the root. It must not be
+            present in the current inventory or an error will occur. It must
+            not be None, but rather a valid file id.
+        """
+        inv = self._inventory
+        orig_root_id = inv.root.file_id
+        # TODO: it might be nice to exit early if there was nothing
+        # to do, saving us from trigger a sync on unlock.
+        self._inventory_is_modified = True
+        # we preserve the root inventory entry object, but
+        # unlinkit from the byid index
+        del inv._byid[inv.root.file_id]
+        inv.root.file_id = file_id
+        # and link it into the index with the new changed id.
+        inv._byid[inv.root.file_id] = inv.root
+        # and finally update all children to reference the new id.
+        # XXX: this should be safe to just look at the root.children
+        # list, not the WHOLE INVENTORY.
+        for fid in inv:
+            entry = inv[fid]
+            if entry.parent_id == orig_root_id:
+                entry.parent_id = inv.root.file_id
+
+    def all_file_ids(self):
+        """See Tree.iter_all_file_ids"""
+        return set(self.inventory)
+
+    def _cache_basis_inventory(self, new_revision):
+        """Cache new_revision as the basis inventory."""
+        # TODO: this should allow the ready-to-use inventory to be passed in,
+        # as commit already has that ready-to-use [while the format is the
+        # same, that is].
+        try:
+            # this double handles the inventory - unpack and repack -
+            # but is easier to understand. We can/should put a conditional
+            # in here based on whether the inventory is in the latest format
+            # - perhaps we should repack all inventories on a repository
+            # upgrade ?
+            # the fast path is to copy the raw xml from the repository. If the
+            # xml contains 'revision_id="', then we assume the right
+            # revision_id is set. We must check for this full string, because a
+            # root node id can legitimately look like 'revision_id' but cannot
+            # contain a '"'.
+            xml = self.branch.repository._get_inventory_xml(new_revision)
+            firstline = xml.split('\n', 1)[0]
+            if (not 'revision_id="' in firstline or
+                'format="7"' not in firstline):
+                inv = self.branch.repository._serializer.read_inventory_from_string(
+                    xml, new_revision)
+                xml = self._create_basis_xml_from_inventory(new_revision, inv)
+            self._write_basis_inventory(xml)
+        except (errors.NoSuchRevision, errors.RevisionNotPresent):
+            pass
+
+    def _basis_inventory_name(self):
+        return 'basis-inventory-cache'
+
+    def _create_basis_xml_from_inventory(self, revision_id, inventory):
+        """Create the text that will be saved in basis-inventory"""
+        inventory.revision_id = revision_id
+        return xml7.serializer_v7.write_inventory_to_string(inventory)
+
+    def read_basis_inventory(self):
+        """Read the cached basis inventory."""
+        path = self._basis_inventory_name()
+        return self._transport.get_bytes(path)
+
+    @needs_read_lock
+    def read_working_inventory(self):
+        """Read the working inventory.
+
+        :raises errors.InventoryModified: read_working_inventory will fail
+            when the current in memory inventory has been modified.
+        """
+        # conceptually this should be an implementation detail of the tree.
+        # XXX: Deprecate this.
+        # ElementTree does its own conversion from UTF-8, so open in
+        # binary.
+        if self._inventory_is_modified:
+            raise errors.InventoryModified(self)
+        f = self._transport.get('inventory')
+        try:
+            result = self._deserialize(f)
+        finally:
+            f.close()
+        self._set_inventory(result, dirty=False)
+        return result
+
+    @needs_read_lock
+    def get_root_id(self):
+        """Return the id of this trees root"""
+        return self._inventory.root.file_id
+
+    def has_id(self, file_id):
+        # files that have been deleted are excluded
+        inv = self.inventory
+        if not inv.has_id(file_id):
+            return False
+        path = inv.id2path(file_id)
+        return osutils.lexists(self.abspath(path))
+
+    def has_or_had_id(self, file_id):
+        if file_id == self.inventory.root.file_id:
+            return True
+        return self.inventory.has_id(file_id)
+
+    __contains__ = has_id
+
+    # should be deprecated - this is slow and in any case treating them as a
+    # container is (we now know) bad style -- mbp 20070302
+    ## @deprecated_method(zero_fifteen)
+    def __iter__(self):
+        """Iterate through file_ids for this tree.
+
+        file_ids are in a WorkingTree if they are in the working inventory
+        and the working file exists.
+        """
+        inv = self._inventory
+        for path, ie in inv.iter_entries():
+            if osutils.lexists(self.abspath(path)):
+                yield ie.file_id
+
+    @needs_tree_write_lock
+    def set_last_revision(self, new_revision):
+        """Change the last revision in the working tree."""
+        if self._change_last_revision(new_revision):
+            self._cache_basis_inventory(new_revision)
+
+    @needs_tree_write_lock
+    def reset_state(self, revision_ids=None):
+        """Reset the state of the working tree.
+
+        This does a hard-reset to a last-known-good state. This is a way to
+        fix if something got corrupted (like the .bzr/checkout/dirstate file)
+        """
+        if revision_ids is None:
+            revision_ids = self.get_parent_ids()
+        if not revision_ids:
+            rt = self.branch.repository.revision_tree(
+                _mod_revision.NULL_REVISION)
+        else:
+            rt = self.branch.repository.revision_tree(revision_ids[0])
+        self._write_inventory(rt.inventory)
+        self.set_parent_ids(revision_ids)
+
+    def flush(self):
+        """Write the in memory inventory to disk."""
+        # TODO: Maybe this should only write on dirty ?
+        if self._control_files._lock_mode != 'w':
+            raise errors.NotWriteLocked(self)
+        sio = StringIO()
+        self._serialize(self._inventory, sio)
+        sio.seek(0)
+        self._transport.put_file('inventory', sio,
+            mode=self.bzrdir._get_file_mode())
+        self._inventory_is_modified = False
+
+    @needs_read_lock
+    def get_file_sha1(self, file_id, path=None, stat_value=None):
+        if not path:
+            path = self._inventory.id2path(file_id)
+        return self._hashcache.get_sha1(path, stat_value)
+
+    def get_file_mtime(self, file_id, path=None):
+        """See Tree.get_file_mtime."""
+        if not path:
+            path = self.inventory.id2path(file_id)
+        return os.lstat(self.abspath(path)).st_mtime
+
+    def _is_executable_from_path_and_stat_from_basis(self, path, stat_result):
+        file_id = self.path2id(path)
+        if file_id is None:
+            # For unversioned files on win32, we just assume they are not
+            # executable
+            return False
+        return self._inventory[file_id].executable
+
+    def _is_executable_from_path_and_stat_from_stat(self, path, stat_result):
+        mode = stat_result.st_mode
+        return bool(stat.S_ISREG(mode) and stat.S_IEXEC & mode)
+
+    if not supports_executable():
+        def is_executable(self, file_id, path=None):
+            return self._inventory[file_id].executable
+
+        _is_executable_from_path_and_stat = \
+            _is_executable_from_path_and_stat_from_basis
+    else:
+        def is_executable(self, file_id, path=None):
+            if not path:
+                path = self.id2path(file_id)
+            mode = os.lstat(self.abspath(path)).st_mode
+            return bool(stat.S_ISREG(mode) and stat.S_IEXEC & mode)
+
+        _is_executable_from_path_and_stat = \
+            _is_executable_from_path_and_stat_from_stat
+
+    @needs_tree_write_lock
+    def _add(self, files, ids, kinds):
+        """See MutableTree._add."""
+        # TODO: Re-adding a file that is removed in the working copy
+        # should probably put it back with the previous ID.
+        # the read and write working inventory should not occur in this
+        # function - they should be part of lock_write and unlock.
+        inv = self.inventory
+        for f, file_id, kind in zip(files, ids, kinds):
+            if file_id is None:
+                inv.add_path(f, kind=kind)
+            else:
+                inv.add_path(f, kind=kind, file_id=file_id)
+            self._inventory_is_modified = True
+
+    def revision_tree(self, revision_id):
+        """See WorkingTree.revision_id."""
+        if revision_id == self.last_revision():
+            try:
+                xml = self.read_basis_inventory()
+            except errors.NoSuchFile:
+                pass
+            else:
+                try:
+                    inv = xml7.serializer_v7.read_inventory_from_string(xml)
+                    # dont use the repository revision_tree api because we want
+                    # to supply the inventory.
+                    if inv.revision_id == revision_id:
+                        return revisiontree.RevisionTree(self.branch.repository,
+                            inv, revision_id)
+                except errors.BadInventoryFormat:
+                    pass
+        # raise if there was no inventory, or if we read the wrong inventory.
+        raise errors.NoSuchRevisionInTree(self, revision_id)
+
+    @needs_read_lock
+    def annotate_iter(self, file_id, default_revision=CURRENT_REVISION):
+        """See Tree.annotate_iter
+
+        This implementation will use the basis tree implementation if possible.
+        Lines not in the basis are attributed to CURRENT_REVISION
+
+        If there are pending merges, lines added by those merges will be
+        incorrectly attributed to CURRENT_REVISION (but after committing, the
+        attribution will be correct).
+        """
+        maybe_file_parent_keys = []
+        for parent_id in self.get_parent_ids():
+            try:
+                parent_tree = self.revision_tree(parent_id)
+            except errors.NoSuchRevisionInTree:
+                parent_tree = self.branch.repository.revision_tree(parent_id)
+            parent_tree.lock_read()
+            try:
+                if file_id not in parent_tree:
+                    continue
+                ie = parent_tree.inventory[file_id]
+                if ie.kind != 'file':
+                    # Note: this is slightly unnecessary, because symlinks and
+                    # directories have a "text" which is the empty text, and we
+                    # know that won't mess up annotations. But it seems cleaner
+                    continue
+                parent_text_key = (file_id, ie.revision)
+                if parent_text_key not in maybe_file_parent_keys:
+                    maybe_file_parent_keys.append(parent_text_key)
+            finally:
+                parent_tree.unlock()
+        graph = _mod_graph.Graph(self.branch.repository.texts)
+        heads = graph.heads(maybe_file_parent_keys)
+        file_parent_keys = []
+        for key in maybe_file_parent_keys:
+            if key in heads:
+                file_parent_keys.append(key)
+
+        # Now we have the parents of this content
+        annotator = self.branch.repository.texts.get_annotator()
+        text = self.get_file_text(file_id)
+        this_key =(file_id, default_revision)
+        annotator.add_special_text(this_key, file_parent_keys, text)
+        annotations = [(key[-1], line)
+                       for key, line in annotator.annotate_flat(this_key)]
+        return annotations
+
+    @needs_read_lock
+    def merge_modified(self):
+        """Return a dictionary of files modified by a merge.
+
+        The list is initialized by WorkingTree.set_merge_modified, which is
+        typically called after we make some automatic updates to the tree
+        because of a merge.
+
+        This returns a map of file_id->sha1, containing only files which are
+        still in the working inventory and have that text hash.
+        """
+        try:
+            hashfile = self._transport.get('merge-hashes')
+        except errors.NoSuchFile:
+            return {}
+        try:
+            merge_hashes = {}
+            try:
+                if hashfile.next() != MERGE_MODIFIED_HEADER_1 + '\n':
+                    raise errors.MergeModifiedFormatError()
+            except StopIteration:
+                raise errors.MergeModifiedFormatError()
+            for s in _mod_rio.RioReader(hashfile):
+                # RioReader reads in Unicode, so convert file_ids back to utf8
+                file_id = osutils.safe_file_id(s.get("file_id"), warn=False)
+                if file_id not in self.inventory:
+                    continue
+                text_hash = s.get("hash")
+                if text_hash == self.get_file_sha1(file_id):
+                    merge_hashes[file_id] = text_hash
+            return merge_hashes
+        finally:
+            hashfile.close()
+
+    @needs_write_lock
+    def subsume(self, other_tree):
+        def add_children(inventory, entry):
+            for child_entry in entry.children.values():
+                inventory._byid[child_entry.file_id] = child_entry
+                if child_entry.kind == 'directory':
+                    add_children(inventory, child_entry)
+        if other_tree.get_root_id() == self.get_root_id():
+            raise errors.BadSubsumeSource(self, other_tree,
+                                          'Trees have the same root')
+        try:
+            other_tree_path = self.relpath(other_tree.basedir)
+        except errors.PathNotChild:
+            raise errors.BadSubsumeSource(self, other_tree,
+                'Tree is not contained by the other')
+        new_root_parent = self.path2id(osutils.dirname(other_tree_path))
+        if new_root_parent is None:
+            raise errors.BadSubsumeSource(self, other_tree,
+                'Parent directory is not versioned.')
+        # We need to ensure that the result of a fetch will have a
+        # versionedfile for the other_tree root, and only fetching into
+        # RepositoryKnit2 guarantees that.
+        if not self.branch.repository.supports_rich_root():
+            raise errors.SubsumeTargetNeedsUpgrade(other_tree)
+        other_tree.lock_tree_write()
+        try:
+            new_parents = other_tree.get_parent_ids()
+            other_root = other_tree.inventory.root
+            other_root.parent_id = new_root_parent
+            other_root.name = osutils.basename(other_tree_path)
+            self.inventory.add(other_root)
+            add_children(self.inventory, other_root)
+            self._write_inventory(self.inventory)
+            # normally we don't want to fetch whole repositories, but i think
+            # here we really do want to consolidate the whole thing.
+            for parent_id in other_tree.get_parent_ids():
+                self.branch.fetch(other_tree.branch, parent_id)
+                self.add_parent_tree_id(parent_id)
+        finally:
+            other_tree.unlock()
+        other_tree.bzrdir.retire_bzrdir()
+
+    @needs_tree_write_lock
+    def extract(self, file_id, format=None):
+        """Extract a subtree from this tree.
+
+        A new branch will be created, relative to the path for this tree.
+        """
+        self.flush()
+        def mkdirs(path):
+            segments = osutils.splitpath(path)
+            transport = self.branch.bzrdir.root_transport
+            for name in segments:
+                transport = transport.clone(name)
+                transport.ensure_base()
+            return transport
+
+        sub_path = self.id2path(file_id)
+        branch_transport = mkdirs(sub_path)
+        if format is None:
+            format = self.bzrdir.cloning_metadir()
+        branch_transport.ensure_base()
+        branch_bzrdir = format.initialize_on_transport(branch_transport)
+        try:
+            repo = branch_bzrdir.find_repository()
+        except errors.NoRepositoryPresent:
+            repo = branch_bzrdir.create_repository()
+        if not repo.supports_rich_root():
+            raise errors.RootNotRich()
+        new_branch = branch_bzrdir.create_branch()
+        new_branch.pull(self.branch)
+        for parent_id in self.get_parent_ids():
+            new_branch.fetch(self.branch, parent_id)
+        tree_transport = self.bzrdir.root_transport.clone(sub_path)
+        if tree_transport.base != branch_transport.base:
+            tree_bzrdir = format.initialize_on_transport(tree_transport)
+            branch.BranchReferenceFormat().initialize(tree_bzrdir,
+                target_branch=new_branch)
+        else:
+            tree_bzrdir = branch_bzrdir
+        wt = tree_bzrdir.create_workingtree(_mod_revision.NULL_REVISION)
+        wt.set_parent_ids(self.get_parent_ids())
+        my_inv = self.inventory
+        child_inv = inventory.Inventory(root_id=None)
+        new_root = my_inv[file_id]
+        my_inv.remove_recursive_id(file_id)
+        new_root.parent_id = None
+        child_inv.add(new_root)
+        self._write_inventory(my_inv)
+        wt._write_inventory(child_inv)
+        return wt
+
+    def list_files(self, include_root=False, from_dir=None, recursive=True):
+        """List all files as (path, class, kind, id, entry).
+
+        Lists, but does not descend into unversioned directories.
+        This does not include files that have been deleted in this
+        tree. Skips the control directory.
+
+        :param include_root: if True, return an entry for the root
+        :param from_dir: start from this directory or None for the root
+        :param recursive: whether to recurse into subdirectories or not
+        """
+        # list_files is an iterator, so @needs_read_lock doesn't work properly
+        # with it. So callers should be careful to always read_lock the tree.
+        if not self.is_locked():
+            raise errors.ObjectNotLocked(self)
+
+        inv = self.inventory
+        if from_dir is None and include_root is True:
+            yield ('', 'V', 'directory', inv.root.file_id, inv.root)
+        # Convert these into local objects to save lookup times
+        pathjoin = osutils.pathjoin
+        file_kind = self._kind
+
+        # transport.base ends in a slash, we want the piece
+        # between the last two slashes
+        transport_base_dir = self.bzrdir.transport.base.rsplit('/', 2)[1]
+
+        fk_entries = {'directory':TreeDirectory, 'file':TreeFile, 'symlink':TreeLink}
+
+        # directory file_id, relative path, absolute path, reverse sorted children
+        if from_dir is not None:
+            from_dir_id = inv.path2id(from_dir)
+            if from_dir_id is None:
+                # Directory not versioned
+                return
+            from_dir_abspath = pathjoin(self.basedir, from_dir)
+        else:
+            from_dir_id = inv.root.file_id
+            from_dir_abspath = self.basedir
+        children = os.listdir(from_dir_abspath)
+        children.sort()
+        # jam 20060527 The kernel sized tree seems equivalent whether we
+        # use a deque and popleft to keep them sorted, or if we use a plain
+        # list and just reverse() them.
+        children = collections.deque(children)
+        stack = [(from_dir_id, u'', from_dir_abspath, children)]
+        while stack:
+            from_dir_id, from_dir_relpath, from_dir_abspath, children = stack[-1]
+
+            while children:
+                f = children.popleft()
+                ## TODO: If we find a subdirectory with its own .bzr
+                ## directory, then that is a separate tree and we
+                ## should exclude it.
+
+                # the bzrdir for this tree
+                if transport_base_dir == f:
+                    continue
+
+                # we know that from_dir_relpath and from_dir_abspath never end in a slash
+                # and 'f' doesn't begin with one, we can do a string op, rather
+                # than the checks of pathjoin(), all relative paths will have an extra slash
+                # at the beginning
+                fp = from_dir_relpath + '/' + f
+
+                # absolute path
+                fap = from_dir_abspath + '/' + f
+
+                dir_ie = inv[from_dir_id]
+                if dir_ie.kind == 'directory':
+                    f_ie = dir_ie.children.get(f)
+                else:
+                    f_ie = None
+                if f_ie:
+                    c = 'V'
+                elif self.is_ignored(fp[1:]):
+                    c = 'I'
+                else:
+                    # we may not have found this file, because of a unicode
+                    # issue, or because the directory was actually a symlink.
+                    f_norm, can_access = osutils.normalized_filename(f)
+                    if f == f_norm or not can_access:
+                        # No change, so treat this file normally
+                        c = '?'
+                    else:
+                        # this file can be accessed by a normalized path
+                        # check again if it is versioned
+                        # these lines are repeated here for performance
+                        f = f_norm
+                        fp = from_dir_relpath + '/' + f
+                        fap = from_dir_abspath + '/' + f
+                        f_ie = inv.get_child(from_dir_id, f)
+                        if f_ie:
+                            c = 'V'
+                        elif self.is_ignored(fp[1:]):
+                            c = 'I'
+                        else:
+                            c = '?'
+
+                fk = file_kind(fap)
+
+                # make a last minute entry
+                if f_ie:
+                    yield fp[1:], c, fk, f_ie.file_id, f_ie
+                else:
+                    try:
+                        yield fp[1:], c, fk, None, fk_entries[fk]()
+                    except KeyError:
+                        yield fp[1:], c, fk, None, TreeEntry()
+                    continue
+
+                if fk != 'directory':
+                    continue
+
+                # But do this child first if recursing down
+                if recursive:
+                    new_children = os.listdir(fap)
+                    new_children.sort()
+                    new_children = collections.deque(new_children)
+                    stack.append((f_ie.file_id, fp, fap, new_children))
+                    # Break out of inner loop,
+                    # so that we start outer loop with child
+                    break
+            else:
+                # if we finished all children, pop it off the stack
+                stack.pop()
+
+    @needs_tree_write_lock
+    def move(self, from_paths, to_dir=None, after=False):
+        """Rename files.
+
+        to_dir must exist in the inventory.
+
+        If to_dir exists and is a directory, the files are moved into
+        it, keeping their old names.
+
+        Note that to_dir is only the last component of the new name;
+        this doesn't change the directory.
+
+        For each entry in from_paths the move mode will be determined
+        independently.
+
+        The first mode moves the file in the filesystem and updates the
+        inventory. The second mode only updates the inventory without
+        touching the file on the filesystem.
+
+        move uses the second mode if 'after == True' and the target is not
+        versioned but present in the working tree.
+
+        move uses the second mode if 'after == False' and the source is
+        versioned but no longer in the working tree, and the target is not
+        versioned but present in the working tree.
+
+        move uses the first mode if 'after == False' and the source is
+        versioned and present in the working tree, and the target is not
+        versioned and not present in the working tree.
+
+        Everything else results in an error.
+
+        This returns a list of (from_path, to_path) pairs for each
+        entry that is moved.
+        """
+        rename_entries = []
+        rename_tuples = []
+
+        # check for deprecated use of signature
+        if to_dir is None:
+            raise TypeError('You must supply a target directory')
+        # check destination directory
+        if isinstance(from_paths, basestring):
+            raise ValueError()
+        inv = self.inventory
+        to_abs = self.abspath(to_dir)
+        if not isdir(to_abs):
+            raise errors.BzrMoveFailedError('',to_dir,
+                errors.NotADirectory(to_abs))
+        if not self.has_filename(to_dir):
+            raise errors.BzrMoveFailedError('',to_dir,
+                errors.NotInWorkingDirectory(to_dir))
+        to_dir_id = inv.path2id(to_dir)
+        if to_dir_id is None:
+            raise errors.BzrMoveFailedError('',to_dir,
+                errors.NotVersionedError(path=to_dir))
+
+        to_dir_ie = inv[to_dir_id]
+        if to_dir_ie.kind != 'directory':
+            raise errors.BzrMoveFailedError('',to_dir,
+                errors.NotADirectory(to_abs))
+
+        # create rename entries and tuples
+        for from_rel in from_paths:
+            from_tail = splitpath(from_rel)[-1]
+            from_id = inv.path2id(from_rel)
+            if from_id is None:
+                raise errors.BzrMoveFailedError(from_rel,to_dir,
+                    errors.NotVersionedError(path=from_rel))
+
+            from_entry = inv[from_id]
+            from_parent_id = from_entry.parent_id
+            to_rel = pathjoin(to_dir, from_tail)
+            rename_entry = InventoryWorkingTree._RenameEntry(
+                from_rel=from_rel,
+                from_id=from_id,
+                from_tail=from_tail,
+                from_parent_id=from_parent_id,
+                to_rel=to_rel, to_tail=from_tail,
+                to_parent_id=to_dir_id)
+            rename_entries.append(rename_entry)
+            rename_tuples.append((from_rel, to_rel))
+
+        # determine which move mode to use. checks also for movability
+        rename_entries = self._determine_mv_mode(rename_entries, after)
+
+        original_modified = self._inventory_is_modified
+        try:
+            if len(from_paths):
+                self._inventory_is_modified = True
+            self._move(rename_entries)
+        except:
+            # restore the inventory on error
+            self._inventory_is_modified = original_modified
+            raise
+        self._write_inventory(inv)
+        return rename_tuples
+
+    @needs_tree_write_lock
+    def rename_one(self, from_rel, to_rel, after=False):
+        """Rename one file.
+
+        This can change the directory or the filename or both.
+
+        rename_one has several 'modes' to work. First, it can rename a physical
+        file and change the file_id. That is the normal mode. Second, it can
+        only change the file_id without touching any physical file.
+
+        rename_one uses the second mode if 'after == True' and 'to_rel' is not
+        versioned but present in the working tree.
+
+        rename_one uses the second mode if 'after == False' and 'from_rel' is
+        versioned but no longer in the working tree, and 'to_rel' is not
+        versioned but present in the working tree.
+
+        rename_one uses the first mode if 'after == False' and 'from_rel' is
+        versioned and present in the working tree, and 'to_rel' is not
+        versioned and not present in the working tree.
+
+        Everything else results in an error.
+        """
+        inv = self.inventory
+        rename_entries = []
+
+        # create rename entries and tuples
+        from_tail = splitpath(from_rel)[-1]
+        from_id = inv.path2id(from_rel)
+        if from_id is None:
+            # if file is missing in the inventory maybe it's in the basis_tree
+            basis_tree = self.branch.basis_tree()
+            from_id = basis_tree.path2id(from_rel)
+            if from_id is None:
+                raise errors.BzrRenameFailedError(from_rel,to_rel,
+                    errors.NotVersionedError(path=from_rel))
+            # put entry back in the inventory so we can rename it
+            from_entry = basis_tree.inventory[from_id].copy()
+            inv.add(from_entry)
+        else:
+            from_entry = inv[from_id]
+        from_parent_id = from_entry.parent_id
+        to_dir, to_tail = os.path.split(to_rel)
+        to_dir_id = inv.path2id(to_dir)
+        rename_entry = InventoryWorkingTree._RenameEntry(from_rel=from_rel,
+                                     from_id=from_id,
+                                     from_tail=from_tail,
+                                     from_parent_id=from_parent_id,
+                                     to_rel=to_rel, to_tail=to_tail,
+                                     to_parent_id=to_dir_id)
+        rename_entries.append(rename_entry)
+
+        # determine which move mode to use. checks also for movability
+        rename_entries = self._determine_mv_mode(rename_entries, after)
+
+        # check if the target changed directory and if the target directory is
+        # versioned
+        if to_dir_id is None:
+            raise errors.BzrMoveFailedError(from_rel,to_rel,
+                errors.NotVersionedError(path=to_dir))
+
+        # all checks done. now we can continue with our actual work
+        mutter('rename_one:\n'
+               '  from_id   {%s}\n'
+               '  from_rel: %r\n'
+               '  to_rel:   %r\n'
+               '  to_dir    %r\n'
+               '  to_dir_id {%s}\n',
+               from_id, from_rel, to_rel, to_dir, to_dir_id)
+
+        self._move(rename_entries)
+        self._write_inventory(inv)
+
+    class _RenameEntry(object):
+        def __init__(self, from_rel, from_id, from_tail, from_parent_id,
+                     to_rel, to_tail, to_parent_id, only_change_inv=False):
+            self.from_rel = from_rel
+            self.from_id = from_id
+            self.from_tail = from_tail
+            self.from_parent_id = from_parent_id
+            self.to_rel = to_rel
+            self.to_tail = to_tail
+            self.to_parent_id = to_parent_id
+            self.only_change_inv = only_change_inv
+
+    def _determine_mv_mode(self, rename_entries, after=False):
+        """Determines for each from-to pair if both inventory and working tree
+        or only the inventory has to be changed.
+
+        Also does basic plausability tests.
+        """
+        inv = self.inventory
+
+        for rename_entry in rename_entries:
+            # store to local variables for easier reference
+            from_rel = rename_entry.from_rel
+            from_id = rename_entry.from_id
+            to_rel = rename_entry.to_rel
+            to_id = inv.path2id(to_rel)
+            only_change_inv = False
+
+            # check the inventory for source and destination
+            if from_id is None:
+                raise errors.BzrMoveFailedError(from_rel,to_rel,
+                    errors.NotVersionedError(path=from_rel))
+            if to_id is not None:
+                raise errors.BzrMoveFailedError(from_rel,to_rel,
+                    errors.AlreadyVersionedError(path=to_rel))
+
+            # try to determine the mode for rename (only change inv or change
+            # inv and file system)
+            if after:
+                if not self.has_filename(to_rel):
+                    raise errors.BzrMoveFailedError(from_id,to_rel,
+                        errors.NoSuchFile(path=to_rel,
+                        extra="New file has not been created yet"))
+                only_change_inv = True
+            elif not self.has_filename(from_rel) and self.has_filename(to_rel):
+                only_change_inv = True
+            elif self.has_filename(from_rel) and not self.has_filename(to_rel):
+                only_change_inv = False
+            elif (not self.case_sensitive
+                  and from_rel.lower() == to_rel.lower()
+                  and self.has_filename(from_rel)):
+                only_change_inv = False
+            else:
+                # something is wrong, so lets determine what exactly
+                if not self.has_filename(from_rel) and \
+                   not self.has_filename(to_rel):
+                    raise errors.BzrRenameFailedError(from_rel,to_rel,
+                        errors.PathsDoNotExist(paths=(str(from_rel),
+                        str(to_rel))))
+                else:
+                    raise errors.RenameFailedFilesExist(from_rel, to_rel)
+            rename_entry.only_change_inv = only_change_inv
+        return rename_entries
+
+    def _move(self, rename_entries):
+        """Moves a list of files.
+
+        Depending on the value of the flag 'only_change_inv', the
+        file will be moved on the file system or not.
+        """
+        inv = self.inventory
+        moved = []
+
+        for entry in rename_entries:
+            try:
+                self._move_entry(entry)
+            except:
+                self._rollback_move(moved)
+                raise
+            moved.append(entry)
+
+    def _rollback_move(self, moved):
+        """Try to rollback a previous move in case of an filesystem error."""
+        inv = self.inventory
+        for entry in moved:
+            try:
+                self._move_entry(WorkingTree._RenameEntry(
+                    entry.to_rel, entry.from_id,
+                    entry.to_tail, entry.to_parent_id, entry.from_rel,
+                    entry.from_tail, entry.from_parent_id,
+                    entry.only_change_inv))
+            except errors.BzrMoveFailedError, e:
+                raise errors.BzrMoveFailedError( '', '', "Rollback failed."
+                        " The working tree is in an inconsistent state."
+                        " Please consider doing a 'bzr revert'."
+                        " Error message is: %s" % e)
+
+    def _move_entry(self, entry):
+        inv = self.inventory
+        from_rel_abs = self.abspath(entry.from_rel)
+        to_rel_abs = self.abspath(entry.to_rel)
+        if from_rel_abs == to_rel_abs:
+            raise errors.BzrMoveFailedError(entry.from_rel, entry.to_rel,
+                "Source and target are identical.")
+
+        if not entry.only_change_inv:
+            try:
+                osutils.rename(from_rel_abs, to_rel_abs)
+            except OSError, e:
+                raise errors.BzrMoveFailedError(entry.from_rel,
+                    entry.to_rel, e[1])
+        inv.rename(entry.from_id, entry.to_parent_id, entry.to_tail)
+
+    @needs_tree_write_lock
+    def unversion(self, file_ids):
+        """Remove the file ids in file_ids from the current versioned set.
+
+        When a file_id is unversioned, all of its children are automatically
+        unversioned.
+
+        :param file_ids: The file ids to stop versioning.
+        :raises: NoSuchId if any fileid is not currently versioned.
+        """
+        for file_id in file_ids:
+            if file_id not in self._inventory:
+                raise errors.NoSuchId(self, file_id)
+        for file_id in file_ids:
+            if self._inventory.has_id(file_id):
+                self._inventory.remove_recursive_id(file_id)
+        if len(file_ids):
+            # in the future this should just set a dirty bit to wait for the
+            # final unlock. However, until all methods of workingtree start
+            # with the current in -memory inventory rather than triggering
+            # a read, it is more complex - we need to teach read_inventory
+            # to know when to read, and when to not read first... and possibly
+            # to save first when the in memory one may be corrupted.
+            # so for now, we just only write it if it is indeed dirty.
+            # - RBC 20060907
+            self._write_inventory(self._inventory)
+
+    def stored_kind(self, file_id):
+        """See Tree.stored_kind"""
+        return self.inventory[file_id].kind
+
+    def extras(self):
+        """Yield all unversioned files in this WorkingTree.
+
+        If there are any unversioned directories then only the directory is
+        returned, not all its children.  But if there are unversioned files
+        under a versioned subdirectory, they are returned.
+
+        Currently returned depth-first, sorted by name within directories.
+        This is the same order used by 'osutils.walkdirs'.
+        """
+        ## TODO: Work from given directory downwards
+        for path, dir_entry in self.inventory.directories():
+            # mutter("search for unknowns in %r", path)
+            dirabs = self.abspath(path)
+            if not isdir(dirabs):
+                # e.g. directory deleted
+                continue
+
+            fl = []
+            for subf in os.listdir(dirabs):
+                if self.bzrdir.is_control_filename(subf):
+                    continue
+                if subf not in dir_entry.children:
+                    try:
+                        (subf_norm,
+                         can_access) = osutils.normalized_filename(subf)
+                    except UnicodeDecodeError:
+                        path_os_enc = path.encode(osutils._fs_enc)
+                        relpath = path_os_enc + '/' + subf
+                        raise errors.BadFilenameEncoding(relpath,
+                                                         osutils._fs_enc)
+                    if subf_norm != subf and can_access:
+                        if subf_norm not in dir_entry.children:
+                            fl.append(subf_norm)
+                    else:
+                        fl.append(subf)
+
+            fl.sort()
+            for subf in fl:
+                subp = pathjoin(path, subf)
+                yield subp
+
+    def _walkdirs(self, prefix=""):
+        """Walk the directories of this tree.
+
+           :prefix: is used as the directrory to start with.
+           returns a generator which yields items in the form:
+                ((curren_directory_path, fileid),
+                 [(file1_path, file1_name, file1_kind, None, file1_id,
+                   file1_kind), ... ])
+        """
+        _directory = 'directory'
+        # get the root in the inventory
+        inv = self.inventory
+        top_id = inv.path2id(prefix)
+        if top_id is None:
+            pending = []
+        else:
+            pending = [(prefix, '', _directory, None, top_id, None)]
+        while pending:
+            dirblock = []
+            currentdir = pending.pop()
+            # 0 - relpath, 1- basename, 2- kind, 3- stat, 4-id, 5-kind
+            top_id = currentdir[4]
+            if currentdir[0]:
+                relroot = currentdir[0] + '/'
+            else:
+                relroot = ""
+            # FIXME: stash the node in pending
+            entry = inv[top_id]
+            if entry.kind == 'directory':
+                for name, child in entry.sorted_children():
+                    dirblock.append((relroot + name, name, child.kind, None,
+                        child.file_id, child.kind
+                        ))
+            yield (currentdir[0], entry.file_id), dirblock
+            # push the user specified dirs from dirblock
+            for dir in reversed(dirblock):
+                if dir[2] == _directory:
+                    pending.append(dir)
+
+
+class WorkingTree3(InventoryWorkingTree):
     """This is the Format 3 working tree.
 
     This differs from the base WorkingTree by:

=== modified file 'doc/en/release-notes/bzr-2.4.txt'
--- doc/en/release-notes/bzr-2.4.txt	2011-04-14 17:34:17 +0000
+++ doc/en/release-notes/bzr-2.4.txt	2011-04-15 10:31:18 +0000
@@ -127,6 +127,11 @@
   from ``bzrlib.repofmt.pack_repo`` to
   ``bzrlib.repofmt.knitpack_repo``. (Jelmer Vernooij)
 
+* ``WorkingTree`` no longer provides an ``inventory``. Instead,
+  all inventory-related functionality is now on the subclass
+  ``InventoryWorkingTree`` that all native Bazaar working tree
+  implementations derive from. (Jelmer Vernooij)
+
 Internals
 *********
 

